/*
 * provision to the core
 * based on LSI interface code improved by Aleksey Kondratenko
 */

#include <linux/module.h>
#include <asm/linkage.h>
#include <linux/pci.h>

#undef memset
asmlinkage
void *memset(void *p, int val, size_t cnt)
{
	return __memset(p, val, cnt);
}

asmlinkage
u32 VMODEM_Get_System_Time(void)
{
	struct timeval time;
	do_gettimeofday(&time);
	return time.tv_usec/1000 + time.tv_sec*1000;
}

u8 inp(u16 addr)
{
	return inb(addr);
}

asmlinkage
void outp(u16 addr, u8 value)
{
	outb(value, addr);
}

asmlinkage
u16 inpw(u16 addr)
{
	return inw(addr);
}

asmlinkage
void outpw(u16 addr, u16 value)
{
	return outw(value, addr);
}

asmlinkage
u32 inpd(u16 addr)
{
	return inl(addr);
}

asmlinkage
void outpd(u16 addr, u32 value)
{
	return outl(value, addr);
}

/* stubs */

struct lt_pci_dev_info;
asmlinkage
unsigned char lt_pci_find_device(struct lt_pci_dev_info *lt_dev, unsigned int id, unsigned int num)
{ return 0; }

void *lt_rs_interrupt = NULL;

/* define pci config access function */
/* Aleksey Kondratenko's courtesy */

#define LT_DEFINE_PCI_OP(rw,size,type)							\
asmlinkage									\
int lt_pcibios_##rw##_config_##size(struct pci_bus *bus, unsigned int dev_fn,	\
				  unsigned char where, unsigned type val)	\
{										\
	struct pci_dev *pcidev = pci_get_slot(bus, dev_fn);			\
	if (!pcidev)								\
		return PCIBIOS_DEVICE_NOT_FOUND;				\
	return pci_##rw##_config_##size(pcidev, where, val);			\
}

LT_DEFINE_PCI_OP(read, byte, char *)
LT_DEFINE_PCI_OP(read, word, short *)
LT_DEFINE_PCI_OP(read, dword, int *)
LT_DEFINE_PCI_OP(write, byte, char)
LT_DEFINE_PCI_OP(write, word, short)
LT_DEFINE_PCI_OP(write, dword, int)

asmlinkage
u8 Get_PCI_INTERRUPT_LINE(void)
{
	return PCI_INTERRUPT_LINE;
}

asmlinkage
u8 Get_PCI_BASE_ADDRESS_1(void)
{
	return PCI_BASE_ADDRESS_1;
}

asmlinkage
u8 Get_PCI_BASE_ADDRESS_2(void)
{
	return PCI_BASE_ADDRESS_2;
}

asmlinkage
u32 Get_PCI_BASE_ADDRESS_IO_MASK(void)
{
	return PCI_BASE_ADDRESS_IO_MASK;
}

asmlinkage
u8 Get_PCI_BASE_ADDRESS_SPACE_IO(void)
{
	return PCI_BASE_ADDRESS_SPACE_IO;
}

asmlinkage
unsigned char lt_pci_present(void)
{
	return 1;
}

void lin_kill(void) {}
void lin_wake_up(void) {}
void lin_interruptible_sleep_on(void) {}
int lin_signal_pending(void) {return 0;}
int function_1(int (*fn)(void *), char *a) {return 0;}
int function_2(char *p) {return 0;}
